/*
      SoundMan v0.1 - Realtime frequency analyzer
      Copyright (C) 1999 Gabor Kerenyi (wom@fireball.kalmar.hu)
*/

#include <qwidget.h>
#include "pldata.h"
#include <qscrollbar.h>
#include <qpainter.h>
#include <fcntl.h>

cnf *pconf;

PLData::PLData(QWidget *parent, const char *name): QWidget(parent,name)
{
setBackgroundMode(PaletteBackground);
setPalette(QPalette(QColor(0,0,0)));
setBackgroundColor(QColor(0,0,0));
}

void PLData::init_cfg(cnf *c)
{
  pconf=c;
}

void PLData::paintEvent(QPaintEvent *)
{
int maxx;
int maxy,basey;
float step;
int step1;
int ee;
long i;
int avg;
float ymag;
QPainter pp;

maxx=width()-15;
maxy=height();
basey=maxy;
ymag=(float)(basey)/(float)255;
step=(float)(pconf->wave.window_length_pn)/(float)maxx;
if (step<1)
   step1=1;
else
   step1=(int)step;
pp.begin(this);
pp.setBrush(QColor(255,255,255));
ee=0;
if (pconf->wave.wave!=NULL)
   for (i=pconf->wave.window_start_pn;i<pconf->wave.window_start_pn+pconf->wave.window_length_pn;i=i+step1)
   {
      avg=(int)((*(pconf->wave.wave+i))*ymag);
      if (i>0) 
	 pp.drawLine((i-pconf->wave.window_start_pn)/step-1,basey-ee,(i-pconf->wave.window_start_pn)/step,basey-avg);
      else
         pp.drawLine((i-pconf->wave.window_start_pn)/(step),220-avg,(i-pconf->wave.window_start_pn)/step,220-avg);
      ee=avg;
   }
   pp.end();
}
